## openmodelica 1.25.4~1-gbfbd502

=== debian/changelog ===
openmodelica (1.25.4~1-gbfbd502-1) unstable; urgency=low

  * Automatic git build
 -- OpenModelica Build System <build@openmodelica.org>  Thu, 25 Sep 2025 12:52:47 -0000
